const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const boms = sequelize.define(
    'boms',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

bom_code: {
        type: DataTypes.TEXT,
      
      

      },

revision_status: {
        type: DataTypes.ENUM,
      
      

        values: [

"draft",


"released",


"obsolete"

        ],

      },

revision: {
        type: DataTypes.TEXT,
      
      

      },

effective_from: {
        type: DataTypes.DATE,
      
      

      },

effective_to: {
        type: DataTypes.DATE,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  boms.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
















    db.boms.hasMany(db.bom_lines, {
      as: 'bom_lines_bom',
      foreignKey: {
          name: 'bomId',
      },
      constraints: false,
    });




    db.boms.hasMany(db.production_orders, {
      as: 'production_orders_bom',
      foreignKey: {
          name: 'bomId',
      },
      constraints: false,
    });












    db.boms.hasMany(db.documents, {
      as: 'documents_bom',
      foreignKey: {
          name: 'bomId',
      },
      constraints: false,
    });



//end loop



    db.boms.belongsTo(db.items, {
      as: 'parent_item',
      foreignKey: {
        name: 'parent_itemId',
      },
      constraints: false,
    });




    db.boms.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.boms.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return boms;
};


